## cg3 0.9.9~r10793

=== CMakeLists.txt ===
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
project(cg3 CXX C)

# Release or Debug
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

set(CMAKE_MACOSX_RPATH ON)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/src/version.hpp" _cg3_VERSION_FILE)
string(REGEX REPLACE ".*CG3_VERSION_MAJOR = ([0-9]+).*" "\\1" _cg3_VERSION_MAJOR ${_cg3_VERSION_FILE})
string(REGEX REPLACE ".*CG3_VERSION_MINOR = ([0-9]+).*" "\\1" _cg3_VERSION_MINOR ${_cg3_VERSION_FILE})
string(REGEX REPLACE ".*CG3_VERSION_PATCH = ([0-9]+).*" "\\1" _cg3_VERSION_PATCH ${_cg3_VERSION_FILE})
string(REGEX REPLACE ".*CG3_REVISION = ([0-9]+).*" "\\1" REVISION ${_cg3_VERSION_FILE})
set(VERSION "${_cg3_VERSION_MAJOR}.${_cg3_VERSION_MINOR}.${_cg3_VERSION_PATCH}.${REVISION}")

# Because Fedora / CentOS / RHEL ...
set(CG_LIBDIR "lib")
if(LIB_INSTALL_DIR)
	string(REGEX REPLACE "^${CMAKE_INSTALL_PREFIX}/" "" CG_LIBDIR ${LIB_INSTALL_DIR})
elseif(LIB_SUFFIX)
	set(CG_LIBDIR "${CG_LIBDIR}${LIB_SUFFIX}")
endif()

option(OPT_TCMALLOC "Set to OFF to disable linking against TCMalloc" ON)
if(APPLE)
	message(STATUS "Disabling TCMalloc for OS X")
	set(OPT_TCMALLOC OFF)
endif()

if(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /EHsc /MP")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT /Ox /Ot /GL /GS-")
	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
	set(CMAKE_C_FLAGS ${CMAKE_CXX_FLAGS})
	set(CMAKE_C_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
else()
	set(_FLAGS_COMMON "-Wall -Wextra -Wno-missing-field-initializers -Wno-deprecated -Wno-unused-parameter -fPIC")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_FLAGS_COMMON} -fvisibility-inlines-hidden")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${_FLAGS_COMMON}")
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g3")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")

	# Enable C++11 if possible
	if((CMAKE_COMPILER_IS_GNUCXX AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.6) OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 3.1))
		message(STATUS "Enabling C++11 for ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
	endif()

	# Generate pkg-config file
	set(prefix      ${CMAKE_INSTALL_PREFIX})
	set(exec_prefix ${CMAKE_INSTALL_PREFIX})
	set(libdir      ${CMAKE_INSTALL_PREFIX}/${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE})
	set(includedir  ${CMAKE_INSTALL_PREFIX}/include)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cg3.pc.in
		${CMAKE_CURRENT_BINARY_DIR}/cg3.pc @ONLY)
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cg3.pc" DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/pkgconfig")

	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/manual/man/"
		DESTINATION share/man/man1
		FILES_MATCHING
		PATTERN "*.1"
		PATTERN ".svn" EXCLUDE)
endif()

if(WIN32)
	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX)
	include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/win32")
else()
	set(POPEN_PLUS_C "${CMAKE_CURRENT_SOURCE_DIR}/include/posix/popen_plus.c" "${CMAKE_CURRENT_SOURCE_DIR}/include/posix/popen_plus.h")
	include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/posix")
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

enable_testing()

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/src)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg3-autobin.pl.in ${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl @ONLY)
install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl" DESTINATION bin)

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/emacs/cg.el" DESTINATION share/emacs/site-lisp)

=== src/CMakeLists.txt ===
# Threading, for exec-stream
# There's some weird bug/interaction with recent Apple toolchains and this, so disable for now.
if(NOT APPLE)
	find_package(Threads REQUIRED)
endif()

# Boost
find_path(Boost_LOCAL NAMES boost/config.hpp PATHS "${CMAKE_CURRENT_SOURCE_DIR}/../include" NO_DEFAULT_PATH)
if(Boost_LOCAL)
	set(BOOST_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/../include")
	find_package(Boost 1.48.0)
endif()
if(NOT Boost_FOUND)
	unset(BOOST_ROOT)
	message(STATUS "Did not find Boost locally; trying globally...")
	message(STATUS "If this doesn't work, run ./get-boost.sh and try again.")
	find_package(Boost 1.48.0 REQUIRED)
endif()
include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

# ICU
find_package(ICU REQUIRED)
if(ICU_FOUND)
	if(ICU_VERSION VERSION_LESS "4.2")
		message(FATAL_ERROR "ICU is too old - ${ICU_VERSION} was found, but CG-3 requires 4.2 or newer")
	endif()
	include_directories(${ICU_INCLUDE_DIRS})
	message(STATUS "Found ICU version ${ICU_VERSION}")
endif()

if(NOT CMAKE_BUILD_TYPE STREQUAL Debug AND OPT_TCMALLOC)
	find_library(GOOGLE_TCMALLOC_LIB tcmalloc)
	if(GOOGLE_TCMALLOC_LIB)
		message(STATUS "Found tcmalloc: ${GOOGLE_TCMALLOC_LIB}")
		set(GOOGLE_TCMALLOC_ENABLED 1)
	else()
		message(STATUS "Can't find tcmalloc - skipping")
	endif()
endif()

macro(cg3_link target)
	if(GOOGLE_TCMALLOC_ENABLED)
		target_link_libraries(${target} ${GOOGLE_TCMALLOC_LIB})
	endif()

	if(WIN32)
		target_link_libraries(${target} "wsock32.lib")
	endif()

	target_link_libraries(${target} ${CMAKE_THREAD_LIBS_INIT})
	target_link_libraries(${target} ${Boost_LIBRARIES})
	target_link_libraries(${target} ${ICU_LIBRARIES} ${ICU_IO_LIBRARIES} ${ICU_I18N_LIBRARIES})
endmacro()

set(LIBCG3_HEADERS
	BinaryGrammar.hpp
	Cohort.hpp
	CohortIterator.hpp
	ContextualTest.hpp
	Grammar.hpp
	GrammarApplicator.hpp
	GrammarWriter.hpp
	IGrammarParser.hpp
	Reading.hpp
	Rule.hpp
	Set.hpp
	SingleWindow.hpp
	Strings.hpp
	Tag.hpp
	TagTrie.hpp
	TextualParser.hpp
	Window.hpp
	bloomish.hpp
	cg3.h
	flat_unordered_map.hpp
	flat_unordered_set.hpp
	inlines.hpp
	interval_vector.hpp
	istream.hpp
	macros.hpp
	parser_helpers.hpp
	process.hpp
	sorted_vector.hpp
	stdafx.hpp
	uextras.hpp
	version.hpp
	)
set(LIBCG3_SOURCES
	BinaryGrammar.cpp
	BinaryGrammar_read.cpp
	BinaryGrammar_read_10043.cpp
	BinaryGrammar_write.cpp
	Cohort.cpp
	CohortIterator.cpp
	ContextualTest.cpp
	Grammar.cpp
	GrammarApplicator.cpp
	GrammarApplicator_matchSet.cpp
	GrammarApplicator_reflow.cpp
	GrammarApplicator_runContextualTest.cpp
	GrammarApplicator_runGrammar.cpp
	GrammarApplicator_runRules.cpp
	GrammarWriter.cpp
	Reading.cpp
	Rule.cpp
	Set.cpp
	SingleWindow.cpp
	Strings.cpp
	Tag.cpp
	TextualParser.cpp
	Window.cpp
	uextras.cpp
	${POPEN_PLUS_C}
	${LIBCG3_HEADERS}
	)
if(MSVC)
	set(LIBCG3_SOURCES
		"${CMAKE_SOURCE_DIR}/include/win32/getopt.c"
		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
		${LIBCG3_SOURCES}
		)
endif()

add_library(libcg3-objs OBJECT ${LIBCG3_SOURCES})

add_library(libcg3 STATIC libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)
set_target_properties(libcg3 PROPERTIES OUTPUT_NAME "cg3")
set_target_properties(libcg3 PROPERTIES PREFIX "lib")
if(MSVC AND NOT CMAKE_BUILD_TYPE STREQUAL Debug)
	set_target_properties(libcg3 PROPERTIES STATIC_LIBRARY_FLAGS "/LTCG")
endif()
cg3_link(libcg3)
set(LINKLIB libcg3)

if(NOT MSVC)
	add_library(libcg3-shared SHARED libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)
	set_target_properties(libcg3-shared PROPERTIES SOVERSION ${_cg3_VERSION_MAJOR})
	set_target_properties(libcg3-shared PROPERTIES OUTPUT_NAME "cg3")
	set_target_properties(libcg3-shared PROPERTIES PREFIX "lib")
	cg3_link(libcg3-shared)
	set(LINKLIB libcg3-shared)
endif()

add_executable(cg-comp cg_comp.cpp)
cg3_link(cg-comp)
target_link_libraries(cg-comp ${LINKLIB})

add_executable(cg-proc
	cg_proc.cpp
	ApertiumApplicator.cpp
	ApertiumApplicator.hpp
	)
cg3_link(cg-proc)
target_link_libraries(cg-proc ${LINKLIB})

add_executable(cg-conv
	cg_conv.cpp
	ApertiumApplicator.cpp
	ApertiumApplicator.hpp
	FormatConverter.cpp
	FormatConverter.hpp
	FSTApplicator.cpp
	FSTApplicator.hpp
	NicelineApplicator.cpp
	NicelineApplicator.hpp
	PlaintextApplicator.cpp
	PlaintextApplicator.hpp
	options_conv.hpp
	)
cg3_link(cg-conv)
target_link_libraries(cg-conv ${LINKLIB})

add_executable(vislcg3 main.cpp options.hpp)
cg3_link(vislcg3)
target_link_libraries(vislcg3 ${LINKLIB})

add_executable(test_libcg3 test_libcg3.c)
target_link_libraries(test_libcg3 ${LINKLIB})

if(APPLE)
	foreach(t cg-conv cg-comp cg-proc vislcg3)
		set("_file_${t}" $<TARGET_FILE:${t}>)
		add_custom_command(
			TARGET ${t}
			POST_BUILD
			COMMAND install_name_tool -change libcg3.0.dylib @rpath/libcg3.0.dylib ${_file_${t}}
			COMMAND install_name_tool -add_rpath @executable_path/ ${_file_${t}}
			COMMAND install_name_tool -add_rpath @executable_path/../${CG_LIBDIR} ${_file_${t}}
			COMMAND install_name_tool -add_rpath @loader_path/../${CG_LIBDIR} ${_file_${t}}
			COMMENT "Adding @rpath to ${t}"
			VERBATIM
		)
	endforeach()
endif()

add_test(t_libcg3 test_libcg3 "${CMAKE_CURRENT_SOURCE_DIR}/../test/T_BasicSelect/grammar.cg3")

install(TARGETS libcg3 ARCHIVE DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}")
if(NOT MSVC)
	install(TARGETS libcg3-shared ARCHIVE DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}" LIBRARY DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}" RUNTIME DESTINATION bin)
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/cg3.h" DESTINATION include)
endif()
install(TARGETS cg-comp cg-proc cg-conv vislcg3 RUNTIME DESTINATION bin)

## cg3 0.9.9~r10439

=== debian/changelog ===
cg3 (0.9.9~r10439-2) unstable; urgency=low

  * debian/control:
    + Fixed FTBFS on buildds. Thanks to Pino Toscano <pino@debian.org> for
      patch (Closes: #789471)

 -- Kartik Mistry <kartik@debian.org>  Sun, 21 Jun 2015 21:21:26 +0530

cg3 (0.9.9~r10439-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Updated to latest from svn.

  [ Kartik Mistry ]
  * Uploaded to unstable.

 -- Kartik Mistry <kartik@debian.org>  Sat, 20 Jun 2015 21:53:32 +0530

cg3 (0.9.9~r10195-1) experimental; urgency=low

  * Updated to latest from svn

 -- Tino Didriksen <mail@tinodidriksen.com>  Tue, 7 Oct 2014 14:36:01 +0000

cg3 (0.9.9~r10190-1) experimental; urgency=low

  * Initial release (Closes: #475452)

 -- Tino Didriksen <mail@tinodidriksen.com>  Fri, 3 Oct 2014 10:31:01 +0000

=== debian/control ===
Source: cg3
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
           Kartik Mistry <kartik@debian.org>
Build-Depends: cmake (>= 2.8.9),
               debhelper (>= 9.0),
               libboost-dev (>= 1.48),
               libicu-dev (>= 4.8)
Standards-Version: 3.9.6
Homepage: http://visl.sdu.dk/cg3.html
Vcs-Git: git://anonscm.debian.org/debian-science/packages/cg3.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git

Package: cg3
Architecture: any
Depends: libcg3-0 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Provides: vislcg3
Conflicts: vislcg3
Replaces: vislcg3
Description: Tools for using the 3rd edition of Constraint Grammar (CG-3)
 Constraint Grammar compiler and applicator for the 3rd edition of CG
 that is developed and maintained by VISL SDU and GrammarSoft ApS.
 .
 CG-3 can be used for disambiguation of morphology, syntax, semantics, etc;
 dependency markup, target language lemma choice for MT, QA systems, and
 much more. The core idea is that you choose what to do based on the whole
 available context, as opposed to n-grams.
 .
 See http://visl.sdu.dk/cg3.html for more documentation

Package: libcg3-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libcg3
Conflicts: libcg3
Replaces: libcg3
Description: Runtime for CG-3
 Runtime library for applications using the CG-3 API.
 .
 It is recommended to instrument the CLI tools instead of using this API.
 .
 See http://visl.sdu.dk/cg3.html for more documentation

Package: libcg3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libcg3-0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Headers and static library to develop using the CG-3 library
 Development files to use the CG-3 API.
 .
 It is recommended to instrument the CLI tools instead of using this API.
 .
 See http://visl.sdu.dk/cg3.html for more documentation

## cg3 0.9.9~r10793

=== debian/changelog ===
cg3 (0.9.9~r10793-1ubuntu2) wily; urgency=medium

  * No-change rebuild against new libicu

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 05 Aug 2015 17:39:27 +0100

cg3 (0.9.9~r10793-1ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 03 Aug 2015 07:53:07 +0000

cg3 (0.9.9~r10793-1) unstable; urgency=low

  * Updated to latest from svn.

 -- Tino Didriksen <mail@tinodidriksen.com>  Sun, 21 Jun 2015 18:59:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cg3
 Section: science
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
            Kartik Mistry <kartik@debian.org>
 Build-Depends: cmake (>= 2.8.9),
@@ -15,7 +16,7 @@
 
 Package: cg3
 Architecture: any
-Depends: libcg3-0 (= ${binary:Version}),
+Depends: libcg3-0v5 (= ${binary:Version}),
          ${misc:Depends},
          ${perl:Depends},
          ${shlibs:Depends}
@@ -33,7 +34,7 @@
  .
  See http://visl.sdu.dk/cg3.html for more documentation
 
-Package: libcg3-0
+Package: libcg3-0v5
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -53,7 +54,7 @@
 Multi-Arch: same
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libcg3-0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libcg3-0v5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Headers and static library to develop using the CG-3 library
  Development files to use the CG-3 API.
  .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ --parallel

=== debian/watch ===
version=3
http://visl.sdu.dk/download/vislcg3/cg3-(.+)\.tar\.bz2

## cg3 0.9.9~r11624

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,10 +25,11 @@
 	set(CG_LIBDIR "${CG_LIBDIR}${LIB_SUFFIX}")
 endif()
 
-option(OPT_TCMALLOC "Set to OFF to disable linking against TCMalloc" ON)
+option(INSTALL_STATIC "Set to ON to install the static library" OFF)
+option(USE_TCMALLOC "Set to OFF to disable linking against TCMalloc" ON)
 if(APPLE)
 	message(STATUS "Disabling TCMalloc for OS X")
-	set(OPT_TCMALLOC OFF)
+	set(USE_TCMALLOC OFF)
 endif()
 
 if(MSVC)
@@ -39,6 +40,9 @@
 	set(CMAKE_C_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
 else()
 	set(_FLAGS_COMMON "-Wall -Wextra -Wno-missing-field-initializers -Wno-deprecated -Wno-unused-parameter -fPIC")
+	if((CMAKE_COMPILER_IS_GNUCXX AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.4) OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
+		set(_FLAGS_COMMON "${_FLAGS_COMMON} -Wno-unused-result")
+	endif()
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_FLAGS_COMMON} -fvisibility-inlines-hidden")
 	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3")
 	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
@@ -46,11 +50,17 @@
 	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g3")
 	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")
 
-	# Enable C++11 if possible
-	if((CMAKE_COMPILER_IS_GNUCXX AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.6) OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 3.1))
-		message(STATUS "Enabling C++11 for ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")
-		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
-	endif()
+	# Enable latest possible C++ standard
+	include(CheckCXXCompilerFlag)
+	foreach(flag "-std=c++17" "-std=c++1z" "-std=c++14" "-std=c++1y" "-std=c++11" "-std=c++0x")
+		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
+		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
+		if(COMPILER_SUPPORTS_${_flag})
+			message(STATUS "Enabling ${flag}")
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
+			break()
+		endif()
+	endforeach()
 
 	# Generate pkg-config file
 	set(prefix      ${CMAKE_INSTALL_PREFIX})
@@ -85,4 +95,5 @@
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg3-autobin.pl.in ${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl @ONLY)
 install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl" DESTINATION bin)
 
-install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/emacs/cg.el" DESTINATION share/emacs/site-lisp)
+set(ELISPDIR "share/emacs/site-lisp" CACHE PATH "Where to install Emacs Lisp files")
+install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/emacs/cg.el" DESTINATION ${ELISPDIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	message(STATUS "Found ICU version ${ICU_VERSION}")
 endif()
 
-if(NOT CMAKE_BUILD_TYPE STREQUAL Debug AND OPT_TCMALLOC)
+if(NOT CMAKE_BUILD_TYPE STREQUAL Debug AND USE_TCMALLOC)
 	find_library(GOOGLE_TCMALLOC_LIB tcmalloc)
 	if(GOOGLE_TCMALLOC_LIB)
 		message(STATUS "Found tcmalloc: ${GOOGLE_TCMALLOC_LIB}")
@@ -54,6 +54,7 @@
 endmacro()
 
 set(LIBCG3_HEADERS
+	AST.hpp
 	BinaryGrammar.hpp
 	Cohort.hpp
 	CohortIterator.hpp
@@ -61,6 +62,8 @@
 	Grammar.hpp
 	GrammarApplicator.hpp
 	GrammarWriter.hpp
+	Relabeller.hpp
+	MweSplitApplicator.hpp
 	IGrammarParser.hpp
 	Reading.hpp
 	Rule.hpp
@@ -78,9 +81,9 @@
 	inlines.hpp
 	interval_vector.hpp
 	istream.hpp
-	macros.hpp
 	parser_helpers.hpp
 	process.hpp
+	scoped_stack.hpp
 	sorted_vector.hpp
 	stdafx.hpp
 	uextras.hpp
@@ -102,6 +105,8 @@
 	GrammarApplicator_runGrammar.cpp
 	GrammarApplicator_runRules.cpp
 	GrammarWriter.cpp
+	Relabeller.cpp
+	MweSplitApplicator.cpp
 	Reading.cpp
 	Rule.cpp
 	Set.cpp
@@ -150,14 +155,22 @@
 	cg_proc.cpp
 	ApertiumApplicator.cpp
 	ApertiumApplicator.hpp
+	MatxinApplicator.cpp
+	MatxinApplicator.hpp
 	)
 cg3_link(cg-proc)
 target_link_libraries(cg-proc ${LINKLIB})
+
+add_executable(cg-relabel cg-relabel.cpp)
+cg3_link(cg-relabel)
+target_link_libraries(cg-relabel ${LINKLIB})
 
 add_executable(cg-conv
 	cg_conv.cpp
 	ApertiumApplicator.cpp
 	ApertiumApplicator.hpp
+	MatxinApplicator.cpp
+	MatxinApplicator.hpp
 	FormatConverter.cpp
 	FormatConverter.hpp
 	FSTApplicator.cpp
@@ -171,6 +184,10 @@
 cg3_link(cg-conv)
 target_link_libraries(cg-conv ${LINKLIB})
 
+add_executable(cg-mwesplit cg-mwesplit.cpp MweSplitApplicator.cpp MweSplitApplicator.hpp)
+cg3_link(cg-mwesplit)
+target_link_libraries(cg-mwesplit ${LINKLIB})
+
 add_executable(vislcg3 main.cpp options.hpp)
 cg3_link(vislcg3)
 target_link_libraries(vislcg3 ${LINKLIB})
@@ -179,7 +196,7 @@
 target_link_libraries(test_libcg3 ${LINKLIB})
 
 if(APPLE)
-	foreach(t cg-conv cg-comp cg-proc vislcg3)
+	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit vislcg3)
 		set("_file_${t}" $<TARGET_FILE:${t}>)
 		add_custom_command(
 			TARGET ${t}
@@ -194,11 +211,14 @@
 	endforeach()
 endif()
 
-add_test(t_libcg3 test_libcg3 "${CMAKE_CURRENT_SOURCE_DIR}/../test/T_BasicSelect/grammar.cg3")
-
-install(TARGETS libcg3 ARCHIVE DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}")
+add_test(t_libcg3 test_libcg3 "${CMAKE_CURRENT_SOURCE_DIR}/../test/T_Select/grammar.cg3")
+
+if(INSTALL_STATIC)
+	install(TARGETS libcg3 ARCHIVE DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}")
+endif()
+
 if(NOT MSVC)
 	install(TARGETS libcg3-shared ARCHIVE DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}" LIBRARY DESTINATION "${CG_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE}" RUNTIME DESTINATION bin)
 	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/cg3.h" DESTINATION include)
 endif()
-install(TARGETS cg-comp cg-proc cg-conv vislcg3 RUNTIME DESTINATION bin)
+install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv vislcg3 RUNTIME DESTINATION bin)

=== debian/changelog ===
cg3 (0.9.9~r11624-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Updated to latest upstream from svn:
    + Fixes assert failure and segfault.
  * Disabled static libraries.

  [ Kartik Mistry ]
  * debian/control:
    + Updated Standards-Version to 3.9.8

 -- Kartik Mistry <kartik@debian.org>  Tue, 07 Jun 2016 09:02:35 +0530

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,21 @@
 Source: cg3
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Tino Didriksen <mail@tinodidriksen.com>,
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Tino Didriksen <tino@didriksen.cc>,
            Kartik Mistry <kartik@debian.org>
 Build-Depends: cmake (>= 2.8.9),
                debhelper (>= 9.0),
-               libboost-dev (>= 1.48),
+               libboost-dev (>= 1.49.0),
                libicu-dev (>= 4.8)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://visl.sdu.dk/cg3.html
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/cg3.git
+Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git
 
 Package: cg3
 Architecture: any
-Depends: libcg3-0v5 (= ${binary:Version}),
+Depends: libcg3-0 (= ${binary:Version}),
          ${misc:Depends},
          ${perl:Depends},
          ${shlibs:Depends}
@@ -34,7 +33,7 @@
  .
  See http://visl.sdu.dk/cg3.html for more documentation
 
-Package: libcg3-0v5
+Package: libcg3-0
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
@@ -54,8 +53,8 @@
 Multi-Arch: same
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libcg3-0v5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Description: Headers and static library to develop using the CG-3 library
+Depends: libcg3-0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Description: Headers and shared files to develop using the CG-3 library
  Development files to use the CG-3 API.
  .
  It is recommended to instrument the CLI tools instead of using this API.

=== debian/rules ===
--- 
+++ 
@@ -18,4 +18,4 @@
 
 
 %:
-	dh $@ --parallel
+	dh $@ --fail-missing --parallel

=== debian/watch ===
version=3
http://visl.sdu.dk/download/cg3/cg3-(.+)\.tar\.bz2

## cg3 1.0.0~r12254

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,9 +40,19 @@
 	set(CMAKE_C_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
 else()
 	set(_FLAGS_COMMON "-Wall -Wextra -Wno-missing-field-initializers -Wno-deprecated -Wno-unused-parameter -fPIC")
-	if((CMAKE_COMPILER_IS_GNUCXX AND NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.4) OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
-		set(_FLAGS_COMMON "${_FLAGS_COMMON} -Wno-unused-result")
+
+	include(CheckCXXCompilerFlag)
+	foreach(flag "-Wno-unused-result" "-flto")
+		string(REGEX REPLACE "[^A-Za-z0-9]" "-" _flag ${flag})
+		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
+		if(COMPILER_SUPPORTS_${_flag})
+			set(_FLAGS_COMMON "${_FLAGS_COMMON} ${flag}")
+		endif()
+	endforeach()
+	if(COMPILER_SUPPORTS_flto)
+		set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -flto")
 	endif()
+
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_FLAGS_COMMON} -fvisibility-inlines-hidden")
 	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3")
 	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
@@ -51,12 +61,10 @@
 	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")
 
 	# Enable latest possible C++ standard
-	include(CheckCXXCompilerFlag)
 	foreach(flag "-std=c++17" "-std=c++1z" "-std=c++14" "-std=c++1y" "-std=c++11" "-std=c++0x")
 		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
 		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
-			message(STATUS "Enabling ${flag}")
 			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
 			break()
 		endif()
@@ -78,6 +86,12 @@
 		PATTERN ".svn" EXCLUDE)
 endif()
 
+include(TestBigEndian)
+TEST_BIG_ENDIAN(BIG_ENDIAN)
+if(BIG_ENDIAN)
+	add_definitions(-DBIG_ENDIAN)
+endif()
+
 if(WIN32)
 	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX)
 	include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/win32")
@@ -94,6 +108,7 @@
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg3-autobin.pl.in ${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl @ONLY)
 install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl" DESTINATION bin)
+install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-strictify" DESTINATION bin)
 
 set(ELISPDIR "share/emacs/site-lisp" CACHE PATH "Where to install Emacs Lisp files")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/emacs/cg.el" DESTINATION ${ELISPDIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -129,14 +129,16 @@
 
 add_library(libcg3-objs OBJECT ${LIBCG3_SOURCES})
 
-add_library(libcg3 STATIC libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)
-set_target_properties(libcg3 PROPERTIES OUTPUT_NAME "cg3")
-set_target_properties(libcg3 PROPERTIES PREFIX "lib")
-if(MSVC AND NOT CMAKE_BUILD_TYPE STREQUAL Debug)
-	set_target_properties(libcg3 PROPERTIES STATIC_LIBRARY_FLAGS "/LTCG")
-endif()
-cg3_link(libcg3)
-set(LINKLIB libcg3)
+if(MSVC OR INSTALL_STATIC)
+	add_library(libcg3 STATIC libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)
+	set_target_properties(libcg3 PROPERTIES OUTPUT_NAME "cg3")
+	set_target_properties(libcg3 PROPERTIES PREFIX "lib")
+	if(MSVC AND NOT CMAKE_BUILD_TYPE STREQUAL Debug)
+		set_target_properties(libcg3 PROPERTIES STATIC_LIBRARY_FLAGS "/LTCG")
+	endif()
+	cg3_link(libcg3)
+	set(LINKLIB libcg3)
+endif()
 
 if(NOT MSVC)
 	add_library(libcg3-shared SHARED libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)

=== debian/changelog ===
cg3 (1.0.0~r12254-1ubuntu3) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:52:27 +0000

cg3 (1.0.0~r12254-1ubuntu2) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Oct 2017 15:39:41 +0000

cg3 (1.0.0~r12254-1ubuntu1) artful; urgency=medium

  * Merge from Debian Sid (LP: #1704258). Remaining changes:
    - Revert the rename of the library packages for the g++5 ABI transition,
      and add Conflicts/Replaces/Provides against the renamed packages. This
      delta can be dropped after Ubuntu 18.04 LTS is released.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 13 Jul 2017 21:25:18 -0500

cg3 (1.0.0~r12254-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Updated to latest upstream release.
  * debian/control:
    + Updated dependencies due to library name change.
    + Updated Homepage.
    + Suggests: libdigest-sha-perl
  * Updated debian/copyright.
  * Updated debian/watch.

  [ Kartik Mistry ]
  * debian/control:
    + Updated Standards-Version to 4.0.0

 -- Kartik Mistry <kartik@debian.org>  Mon, 26 Jun 2017 20:59:00 +0530

cg3 (0.9.9~r11624-1ubuntu1) yakkety; urgency=medium

  * Sync from Debian unstable.
  * Revert the rename of the library packages for the g++5 ABI transition,
    and add conflicts/replaces/provides against the renamed packages. This
    delta can be dropped after the next LTS release (LP: #1512331).

 -- Logan Rosen <logan@ubuntu.com>  Tue, 21 Jun 2016 01:07:20 -0400

=== debian/control ===
Source: cg3
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tino Didriksen <tino@didriksen.cc>,
           Kartik Mistry <kartik@debian.org>
Build-Depends: cmake (>= 2.8.9),
               debhelper (>= 9.0),
               libboost-dev (>= 1.49.0),
               libicu-dev (>= 4.8)
Standards-Version: 4.0.0
Homepage: https://visl.sdu.dk/cg3.html
Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git

Package: cg3
Architecture: any
Depends: libcg3-1 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Provides: vislcg3
Conflicts: vislcg3
Replaces: vislcg3
Suggests: libdigest-sha-perl
Description: Tools for using the 3rd edition of Constraint Grammar (CG-3)
 Constraint Grammar compiler and applicator for the 3rd edition of CG
 that is developed and maintained by VISL SDU and GrammarSoft ApS.
 .
 CG-3 can be used for disambiguation of morphology, syntax, semantics, etc;
 dependency markup, target language lemma choice for MT, QA systems, and
 much more. The core idea is that you choose what to do based on the whole
 available context, as opposed to n-grams.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

Package: libcg3-1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libcg3, libcg3-0v5
Conflicts: libcg3, libcg3-0v5
Replaces: libcg3, libcg3-0v5
Description: Runtime for CG-3
 Runtime library for applications using the CG-3 API.
 .
 It is recommended to instrument the CLI tools instead of using this API.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

Package: libcg3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libcg3-1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Headers and shared files to develop using the CG-3 library
 Development files to use the CG-3 API.
 .
 It is recommended to instrument the CLI tools instead of using this API.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,7 @@
 
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
+export LC_ALL=C.UTF-8
 
 
 %:

## cg3 1.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
 	set(CMAKE_BUILD_TYPE "Release")
 endif()
 
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 set(CMAKE_MACOSX_RPATH ON)
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
 
@@ -33,7 +34,7 @@
 endif()
 
 if(MSVC)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4 /EHsc /MP")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /permissive- /W4 /EHsc /MP")
 	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT /Ox /Ot /GL /GS-")
 	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
 	set(CMAKE_C_FLAGS ${CMAKE_CXX_FLAGS})
@@ -41,7 +42,9 @@
 else()
 	set(_FLAGS_COMMON "-Wall -Wextra -Wno-missing-field-initializers -Wno-deprecated -Wno-unused-parameter -fPIC")
 
+	include(CheckCCompilerFlag)
 	include(CheckCXXCompilerFlag)
+
 	foreach(flag "-Wno-unused-result" "-flto")
 		string(REGEX REPLACE "[^A-Za-z0-9]" "-" _flag ${flag})
 		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
@@ -60,15 +63,29 @@
 	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g3")
 	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")
 
-	# Enable latest possible C++ standard
-	foreach(flag "-std=c++17" "-std=c++1z" "-std=c++14" "-std=c++1y" "-std=c++11" "-std=c++0x")
+	# Enable latest possible C standard
+	foreach(flag "-std=c2x" "-std=c11" "-std=c1x" "-std=c99")
+		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
+		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
+		if(COMPILER_SUPPORTS_${_flag})
+			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
+			break()
+		endif()
+	endforeach()
+
+	# Require latest possible C++ standard
+	foreach(flag "-std=c++20" "-std=c++2a" "-std=c++17" "-std=c++1z" "-std=c++14" "-std=c++1y")
 		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
 		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
 			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
+			set(_ENABLED_CXX ${flag})
 			break()
 		endif()
 	endforeach()
+	if(NOT _ENABLED_CXX)
+		message(FATAL_ERROR "Could not enable at least C++14 (C++1y) - upgrade your compiler")
+	endif()
 
 	# Generate pkg-config file
 	set(prefix      ${CMAKE_INSTALL_PREFIX})
@@ -96,6 +113,7 @@
 	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX)
 	include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/win32")
 else()
+	add_definitions(-D_POSIX_C_SOURCE=200112)
 	set(POPEN_PLUS_C "${CMAKE_CURRENT_SOURCE_DIR}/include/posix/popen_plus.c" "${CMAKE_CURRENT_SOURCE_DIR}/include/posix/popen_plus.h")
 	include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/posix")
 endif()
@@ -107,8 +125,12 @@
 add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/src)
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg3-autobin.pl.in ${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl @ONLY)
-install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl" DESTINATION bin)
-install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-strictify" DESTINATION bin)
+install(PROGRAMS
+	"${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl"
+	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-sort"
+	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-strictify"
+	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-untrace"
+	DESTINATION bin)
 
 set(ELISPDIR "share/emacs/site-lisp" CACHE PATH "Where to install Emacs Lisp files")
 install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/emacs/cg.el" DESTINATION ${ELISPDIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,13 @@
 find_path(Boost_LOCAL NAMES boost/config.hpp PATHS "${CMAKE_CURRENT_SOURCE_DIR}/../include" NO_DEFAULT_PATH)
 if(Boost_LOCAL)
 	set(BOOST_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/../include")
-	find_package(Boost 1.48.0)
+	find_package(Boost 1.53.0)
 endif()
 if(NOT Boost_FOUND)
 	unset(BOOST_ROOT)
 	message(STATUS "Did not find Boost locally; trying globally...")
 	message(STATUS "If this doesn't work, run ./get-boost.sh and try again.")
-	find_package(Boost 1.48.0 REQUIRED)
+	find_package(Boost 1.53.0 REQUIRED)
 endif()
 include_directories(${Boost_INCLUDE_DIRS})
 link_directories(${Boost_LIBRARY_DIRS})
@@ -22,8 +22,8 @@
 # ICU
 find_package(ICU REQUIRED)
 if(ICU_FOUND)
-	if(ICU_VERSION VERSION_LESS "4.2")
-		message(FATAL_ERROR "ICU is too old - ${ICU_VERSION} was found, but CG-3 requires 4.2 or newer")
+	if(ICU_VERSION VERSION_LESS "50.0")
+		message(FATAL_ERROR "ICU is too old - ${ICU_VERSION} was found, but CG-3 requires 50.0 or newer")
 	endif()
 	include_directories(${ICU_INCLUDE_DIRS})
 	message(STATUS "Found ICU version ${ICU_VERSION}")
@@ -80,12 +80,12 @@
 	flat_unordered_set.hpp
 	inlines.hpp
 	interval_vector.hpp
-	istream.hpp
 	parser_helpers.hpp
 	process.hpp
 	scoped_stack.hpp
 	sorted_vector.hpp
 	stdafx.hpp
+	streambuf.hpp
 	uextras.hpp
 	version.hpp
 	)
@@ -127,10 +127,8 @@
 		)
 endif()
 
-add_library(libcg3-objs OBJECT ${LIBCG3_SOURCES})
-
 if(MSVC OR INSTALL_STATIC)
-	add_library(libcg3 STATIC libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)
+	add_library(libcg3 STATIC libcg3.cpp ${LIBCG3_SOURCES})
 	set_target_properties(libcg3 PROPERTIES OUTPUT_NAME "cg3")
 	set_target_properties(libcg3 PROPERTIES PREFIX "lib")
 	if(MSVC AND NOT CMAKE_BUILD_TYPE STREQUAL Debug)
@@ -141,7 +139,7 @@
 endif()
 
 if(NOT MSVC)
-	add_library(libcg3-shared SHARED libcg3.cpp $<TARGET_OBJECTS:libcg3-objs>)
+	add_library(libcg3-shared SHARED libcg3.cpp ${LIBCG3_SOURCES})
 	set_target_properties(libcg3-shared PROPERTIES SOVERSION ${_cg3_VERSION_MAJOR})
 	set_target_properties(libcg3-shared PROPERTIES OUTPUT_NAME "cg3")
 	set_target_properties(libcg3-shared PROPERTIES PREFIX "lib")
@@ -186,7 +184,7 @@
 cg3_link(cg-conv)
 target_link_libraries(cg-conv ${LINKLIB})
 
-add_executable(cg-mwesplit cg-mwesplit.cpp MweSplitApplicator.cpp MweSplitApplicator.hpp)
+add_executable(cg-mwesplit cg-mwesplit.cpp)
 cg3_link(cg-mwesplit)
 target_link_libraries(cg-mwesplit ${LINKLIB})

=== debian/changelog ===
cg3 (1.1.7-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream
  * Removed 00-wrong-path-for-interpreter.diff patch. Merged upstream.

 -- Kartik Mistry <kartik@debian.org>  Fri, 12 Oct 2018 19:23:29 +0530

cg3 (1.0.0~r12254-2) unstable; urgency=low

  * debian/control:
    + Updated Vcs-* URLs.
    + Updated Standards-Version to 4.2.1.0
    + Use 'libs' section for libcg3-1
  * debian/rules:
    + Removed --parallel argument.
    + Added hardening support.
  * Bumped dh to 11.
  * Updated debian/copyright.
  * Use triggers instead of postinst.
  * Added debian/libcg3-1.lintian-overrides - not a duplicate trigger.
  * Added patch to fix wrong path for interpreter.

 -- Kartik Mistry <kartik@debian.org>  Mon, 27 Aug 2018 13:41:04 +0530

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: cg3
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Tino Didriksen <tino@didriksen.cc>,
            Kartik Mistry <kartik@debian.org>
 Build-Depends: cmake (>= 2.8.9),
-               debhelper (>= 9.0),
-               libboost-dev (>= 1.49.0),
-               libicu-dev (>= 4.8)
-Standards-Version: 4.0.0
+               debhelper (>= 11),
+               libboost-dev (>= 1.53.0),
+               libicu-dev (>= 50.0)
+Standards-Version: 4.2.1
 Homepage: https://visl.sdu.dk/cg3.html
-Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/cg3.git
+Vcs-Git: https://salsa.debian.org/science-team/cg3.git
+Vcs-Browser: https://salsa.debian.org/science-team/cg3
 
 Package: cg3
 Architecture: any
@@ -36,13 +35,14 @@
  See https://visl.sdu.dk/cg3.html for more documentation
 
 Package: libcg3-1
+Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Provides: libcg3, libcg3-0v5
-Conflicts: libcg3, libcg3-0v5
-Replaces: libcg3, libcg3-0v5
+Provides: libcg3
+Conflicts: libcg3
+Replaces: libcg3
 Description: Runtime for CG-3
  Runtime library for applications using the CG-3 API.
  .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS
export LC_ALL=C.UTF-8

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --fail-missing

=== debian/watch ===
version=3
https://visl.sdu.dk/download/cg3/cg3-(.+)\.tar\.bz2
